#!/usr/bin/perl -w

# prg: remove_short_seq.pl
# read all fasta files in input folder
# if sequence is shorter than predefined limit, put it into a fasta file, if longer, put it into
#another

#INPUT: xxx.fas 
#OUTPUT: xxx_80.fas (seqs longer than limit)
#	xxx_bellow80.fas (seqs shorter than limit)


  use warnings;
  use strict;
  use subprogramQDD;

my $syst = '';
my $fas_file = '';
my $fas_folder = '';
my $outfolder = '';
my $limit = '';

if ( scalar@ARGV == 5 )
{
   	$syst = $ARGV[0];
    $fas_file = $ARGV[1];
   	$fas_folder = $ARGV[2];
   	$outfolder = $ARGV[3];
   	$limit = $ARGV[4];
}
else
{
	$syst = 'win';
	$fas_file = 'Ea_tag_MID1.tag';
	$fas_folder= 'd:/pipe_clean/QDD2/1307712142/Ea_tag_1307712142';
	$outfolder = 'temp1';
	$limit = 80;
	print "Direct parameters are used in remove_short_seq.pl\n";
}


	my $short = $fas_file;
	$short =~ s/\..*/_bellow$limit\.fas/;
	$short = $outfolder.'/'.$short;
	my $long = $fas_file;
	$long =~ s/\..*/_$limit\.fas/;
	$long =~ s/\./bp\./;
	$long = $outfolder.'/'.$long;
	open_file_out($short, 'SH');
	open_file_out($long, 'LO');
  $fas_file = $fas_folder.'/'.$fas_file;
  open (FAS, $fas_file);

  my $i = 0;
	my $ok = 0;

  while (my $seq = one_seq($fas_file))
  {
		if ($seq eq '>')
		{
			next;
		}
		$seq =~ /.*\n/;
		my $code = $&;
		$seq =~ s/$code//;
		$code =~ s/\s.*//;
		chomp $code;
		$seq =~ s/\s//g;
		$seq =~ s/>//;
		chomp $seq;

		if (length $seq < $limit)
		{
			++$i;
			print SH ">$code\n$seq\n";
		}
		else
		{
			++$ok;
			print LO ">$code\n$seq\n";
		}
  }
#    print OUT "$filename;$i;$ok\n";


    close (FAS);
    close (SH);
    close (LO);

close OUT;

exit;

############################################################


sub one_seq
{
#    read the data concernant one sequence

    my ($filename) = @_; 
    my ($res_seq) = ''; 

    my ($sep_entree) = $/;
    $/ = ">";
    $res_seq = <FAS>;
    $/ = $sep_entree;
    return $res_seq;
}


